What's the purpose of “true” in bash “if sudo true; then”How can I adjust this short shell script to fit my needs?Security of sudo not asking for a password after the first timeCan't give myself NOPASSWD privelege for chmod/chownHow to prevent the caller's shell from being used in sudoScript that asks for four words, then tells the user the word they chose. Output error?Sudo specific command with no passwordHave a command in my $PATH, but it is not being recognized when I use sudoHow to check a set of lines in a text file for patterns using awk, sed, or grep?Which user's password does `sudo` asks for?Does sudo restrict on which users can acquire superuser privileges?
Escape a backup date in a file name
Trouble understanding the speech of overseas colleagues
Two monoidal structures and copowering
Why, precisely, is argon used in neutrino experiments?
Would a high gravity rocky planet be guaranteed to have an atmosphere?
Go Pregnant or Go Home
Was Spock the First Vulcan in Starfleet?
Why escape if the_content isnt?
Proof of work - lottery approach
How to pronounce the slash sign
Is a stroke of luck acceptable after a series of unfavorable events?
Return the Closest Prime Number
Detecting if an element is found inside a container
Why not increase contact surface when reentering the atmosphere?
Sort a list by elements of another list
How do I rename a Linux host without needing to reboot for the rename to take effect?
Class Action - which options I have?
How to be diplomatic in refusing to write code that breaches the privacy of our users
Hostile work environment after whistle-blowing on coworker and our boss. What do I do?
Is there a good way to store credentials outside of a password manager?
Different result between scanning in Epson's "color negative film" mode and scanning in positive -> invert curve in post?
How long to clear the 'suck zone' of a turbofan after start is initiated?
Method to test if a number is a perfect power?
Avoiding estate tax by giving multiple gifts
What's the purpose of “true” in bash “if sudo true; then”
How can I adjust this short shell script to fit my needs?Security of sudo not asking for a password after the first timeCan't give myself NOPASSWD privelege for chmod/chownHow to prevent the caller's shell from being used in sudoScript that asks for four words, then tells the user the word they chose. Output error?Sudo specific command with no passwordHave a command in my $PATH, but it is not being recognized when I use sudoHow to check a set of lines in a text file for patterns using awk, sed, or grep?Which user's password does `sudo` asks for?Does sudo restrict on which users can acquire superuser privileges?
I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)
# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi
echo "do my ops"
Is the purpose of "true" on the fourth line just a null-statement?
I need to invert the test on the fourth line, how do I do so? Here is what I've tried:
if sudo false; then
if sudo true == false; then
if [!(sudo true)]; then
bash sudo
New contributor
|
show 7 more comments
I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)
# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi
echo "do my ops"
Is the purpose of "true" on the fourth line just a null-statement?
I need to invert the test on the fourth line, how do I do so? Here is what I've tried:
if sudo false; then
if sudo true == false; then
if [!(sudo true)]; then
bash sudo
New contributor
2
If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?
– Matt Parkins
yesterday
4
Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?
– Jeff Schaller♦
yesterday
1
see stackoverflow.com/q/10552711/537980
– ctrl-alt-delor
yesterday
1
@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.
– Matt Parkins
yesterday
2
In passing, you probably ought to redirect the error message to the error stream:echo "Aborting script" >&2
– Toby Speight
yesterday
|
show 7 more comments
I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)
# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi
echo "do my ops"
Is the purpose of "true" on the fourth line just a null-statement?
I need to invert the test on the fourth line, how do I do so? Here is what I've tried:
if sudo false; then
if sudo true == false; then
if [!(sudo true)]; then
bash sudo
New contributor
I've hacked together this bash script which tests if the user has superuser privileges and if they don't it asks for them. Ultimately I'm trying to invert the second 'if' statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)
# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi
echo "do my ops"
Is the purpose of "true" on the fourth line just a null-statement?
I need to invert the test on the fourth line, how do I do so? Here is what I've tried:
if sudo false; then
if sudo true == false; then
if [!(sudo true)]; then
bash sudo
bash sudo
New contributor
New contributor
edited 15 hours ago
Matt Parkins
New contributor
asked yesterday
Matt ParkinsMatt Parkins
19717
19717
New contributor
New contributor
2
If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?
– Matt Parkins
yesterday
4
Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?
– Jeff Schaller♦
yesterday
1
see stackoverflow.com/q/10552711/537980
– ctrl-alt-delor
yesterday
1
@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.
– Matt Parkins
yesterday
2
In passing, you probably ought to redirect the error message to the error stream:echo "Aborting script" >&2
– Toby Speight
yesterday
|
show 7 more comments
2
If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?
– Matt Parkins
yesterday
4
Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?
– Jeff Schaller♦
yesterday
1
see stackoverflow.com/q/10552711/537980
– ctrl-alt-delor
yesterday
1
@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.
– Matt Parkins
yesterday
2
In passing, you probably ought to redirect the error message to the error stream:echo "Aborting script" >&2
– Toby Speight
yesterday
2
2
If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?
– Matt Parkins
yesterday
If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?
– Matt Parkins
yesterday
4
4
Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?
– Jeff Schaller♦
yesterday
Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?
– Jeff Schaller♦
yesterday
1
1
see stackoverflow.com/q/10552711/537980
– ctrl-alt-delor
yesterday
see stackoverflow.com/q/10552711/537980
– ctrl-alt-delor
yesterday
1
1
@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.
– Matt Parkins
yesterday
@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.
– Matt Parkins
yesterday
2
2
In passing, you probably ought to redirect the error message to the error stream:
echo "Aborting script" >&2
– Toby Speight
yesterday
In passing, you probably ought to redirect the error message to the error stream:
echo "Aborting script" >&2
– Toby Speight
yesterday
|
show 7 more comments
2 Answers
2
active
oldest
votes
true
in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false
is a program that exits with an unsuccessful exit code.
You can try this out by running both programs from your terminal, and then reading the $?
variable, which contains the exit code of the last program;
true
echo $? # 0
false
echo $? #1
if sudo true
isn't equivalent to if sudo == true
. if sudo true
is running the true
program using sudo
, and checking the exit code.
Therefore:
if sudo false; then
is running the program false
as sudo. The return will always be false.
if sudo true == false
will run the program true
with the arguments ==
and false
using sudo
. This obviously isn't want you intended.
if [!(sudo true)]
is invalid syntax.
What you are probably looking for is
if ! sudo true;
New contributor
10
As a slightly pedantic correction to the first sentence: in bash,true
andfalse
are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know,sudo true
will be running the standalone program, not the bash builtin.
– IMSoP
yesterday
30
PS: my favourite summaries oftrue
andfalse
are the titles on their man pages:true - do nothing, successfully
andfalse - do nothing, unsuccessfully
– IMSoP
yesterday
2
@IMSoP That's deep.
– brainplot
14 hours ago
@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expecttrue
to ever be called nearly often enough to matter.
– John Dvorak
13 hours ago
1
Iftrue
didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.
– nigel222
10 hours ago
|
show 4 more comments
I feel like the accepted answer didn't actually answer your question?
The purpose of doing this is to check that you can actually sudo
.
How this check is performed is via the true
program as explained in the accepted answer.
1
Essentially, this. Alternative could be to check if the user is in sudoers group, but just runningsudo true
is also easy enough of a way, although a bit hacky.
– Sergiy Kolodyazhnyy
yesterday
3
Note that this also requiressudo
to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)
– Mehrdad
yesterday
1
The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.
– mckenzm
23 hours ago
1
And, conversely, you can also be able tosudo
without being in the sudoers group if you (either personally or as a member of some other group) are listed in/etc/sudoers
. But evensudo true
is not infallible, assudo
access can be granted for only specific commands, so you may be able tosudo true
, but not tosudo something_else
, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run withsudo
.
– Dave Sherohman
13 hours ago
2
Also, you can be in thesudoers
group and not be able tosudo
because thesudoers
group is not listed in thesudoers
file. A group with the four letterssudo
in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all usingsudo
.
– jrw32982
8 hours ago
|
show 1 more comment
Your Answer
StackExchange.ready(function()
var channelOptions =
tags: "".split(" "),
id: "106"
;
initTagRenderer("".split(" "), "".split(" "), channelOptions);
StackExchange.using("externalEditor", function()
// Have to fire editor after snippets, if snippets enabled
if (StackExchange.settings.snippets.snippetsEnabled)
StackExchange.using("snippets", function()
createEditor();
);
else
createEditor();
);
function createEditor()
StackExchange.prepareEditor(
heartbeatType: 'answer',
autoActivateHeartbeat: false,
convertImagesToLinks: false,
noModals: true,
showLowRepImageUploadWarning: true,
reputationToPostImages: null,
bindNavPrevention: true,
postfix: "",
imageUploader:
brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
allowUrls: true
,
onDemand: true,
discardSelector: ".discard-answer"
,immediatelyShowMarkdownHelp:true
);
);
Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');
);
Post as a guest
Required, but never shown
2 Answers
2
active
oldest
votes
2 Answers
2
active
oldest
votes
active
oldest
votes
active
oldest
votes
true
in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false
is a program that exits with an unsuccessful exit code.
You can try this out by running both programs from your terminal, and then reading the $?
variable, which contains the exit code of the last program;
true
echo $? # 0
false
echo $? #1
if sudo true
isn't equivalent to if sudo == true
. if sudo true
is running the true
program using sudo
, and checking the exit code.
Therefore:
if sudo false; then
is running the program false
as sudo. The return will always be false.
if sudo true == false
will run the program true
with the arguments ==
and false
using sudo
. This obviously isn't want you intended.
if [!(sudo true)]
is invalid syntax.
What you are probably looking for is
if ! sudo true;
New contributor
10
As a slightly pedantic correction to the first sentence: in bash,true
andfalse
are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know,sudo true
will be running the standalone program, not the bash builtin.
– IMSoP
yesterday
30
PS: my favourite summaries oftrue
andfalse
are the titles on their man pages:true - do nothing, successfully
andfalse - do nothing, unsuccessfully
– IMSoP
yesterday
2
@IMSoP That's deep.
– brainplot
14 hours ago
@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expecttrue
to ever be called nearly often enough to matter.
– John Dvorak
13 hours ago
1
Iftrue
didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.
– nigel222
10 hours ago
|
show 4 more comments
true
in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false
is a program that exits with an unsuccessful exit code.
You can try this out by running both programs from your terminal, and then reading the $?
variable, which contains the exit code of the last program;
true
echo $? # 0
false
echo $? #1
if sudo true
isn't equivalent to if sudo == true
. if sudo true
is running the true
program using sudo
, and checking the exit code.
Therefore:
if sudo false; then
is running the program false
as sudo. The return will always be false.
if sudo true == false
will run the program true
with the arguments ==
and false
using sudo
. This obviously isn't want you intended.
if [!(sudo true)]
is invalid syntax.
What you are probably looking for is
if ! sudo true;
New contributor
10
As a slightly pedantic correction to the first sentence: in bash,true
andfalse
are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know,sudo true
will be running the standalone program, not the bash builtin.
– IMSoP
yesterday
30
PS: my favourite summaries oftrue
andfalse
are the titles on their man pages:true - do nothing, successfully
andfalse - do nothing, unsuccessfully
– IMSoP
yesterday
2
@IMSoP That's deep.
– brainplot
14 hours ago
@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expecttrue
to ever be called nearly often enough to matter.
– John Dvorak
13 hours ago
1
Iftrue
didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.
– nigel222
10 hours ago
|
show 4 more comments
true
in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false
is a program that exits with an unsuccessful exit code.
You can try this out by running both programs from your terminal, and then reading the $?
variable, which contains the exit code of the last program;
true
echo $? # 0
false
echo $? #1
if sudo true
isn't equivalent to if sudo == true
. if sudo true
is running the true
program using sudo
, and checking the exit code.
Therefore:
if sudo false; then
is running the program false
as sudo. The return will always be false.
if sudo true == false
will run the program true
with the arguments ==
and false
using sudo
. This obviously isn't want you intended.
if [!(sudo true)]
is invalid syntax.
What you are probably looking for is
if ! sudo true;
New contributor
true
in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false
is a program that exits with an unsuccessful exit code.
You can try this out by running both programs from your terminal, and then reading the $?
variable, which contains the exit code of the last program;
true
echo $? # 0
false
echo $? #1
if sudo true
isn't equivalent to if sudo == true
. if sudo true
is running the true
program using sudo
, and checking the exit code.
Therefore:
if sudo false; then
is running the program false
as sudo. The return will always be false.
if sudo true == false
will run the program true
with the arguments ==
and false
using sudo
. This obviously isn't want you intended.
if [!(sudo true)]
is invalid syntax.
What you are probably looking for is
if ! sudo true;
New contributor
New contributor
answered yesterday
JShorthouseJShorthouse
50728
50728
New contributor
New contributor
10
As a slightly pedantic correction to the first sentence: in bash,true
andfalse
are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know,sudo true
will be running the standalone program, not the bash builtin.
– IMSoP
yesterday
30
PS: my favourite summaries oftrue
andfalse
are the titles on their man pages:true - do nothing, successfully
andfalse - do nothing, unsuccessfully
– IMSoP
yesterday
2
@IMSoP That's deep.
– brainplot
14 hours ago
@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expecttrue
to ever be called nearly often enough to matter.
– John Dvorak
13 hours ago
1
Iftrue
didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.
– nigel222
10 hours ago
|
show 4 more comments
10
As a slightly pedantic correction to the first sentence: in bash,true
andfalse
are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know,sudo true
will be running the standalone program, not the bash builtin.
– IMSoP
yesterday
30
PS: my favourite summaries oftrue
andfalse
are the titles on their man pages:true - do nothing, successfully
andfalse - do nothing, unsuccessfully
– IMSoP
yesterday
2
@IMSoP That's deep.
– brainplot
14 hours ago
@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expecttrue
to ever be called nearly often enough to matter.
– John Dvorak
13 hours ago
1
Iftrue
didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.
– nigel222
10 hours ago
10
10
As a slightly pedantic correction to the first sentence: in bash,
true
and false
are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true
will be running the standalone program, not the bash builtin.– IMSoP
yesterday
As a slightly pedantic correction to the first sentence: in bash,
true
and false
are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true
will be running the standalone program, not the bash builtin.– IMSoP
yesterday
30
30
PS: my favourite summaries of
true
and false
are the titles on their man pages: true - do nothing, successfully
and false - do nothing, unsuccessfully
– IMSoP
yesterday
PS: my favourite summaries of
true
and false
are the titles on their man pages: true - do nothing, successfully
and false - do nothing, unsuccessfully
– IMSoP
yesterday
2
2
@IMSoP That's deep.
– brainplot
14 hours ago
@IMSoP That's deep.
– brainplot
14 hours ago
@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect
true
to ever be called nearly often enough to matter.– John Dvorak
13 hours ago
@IMSoP I'm curious, what's the point of having shell builtins that exactly duplicate the behavior of some programs? I'm tempted to guess performance, but I'd not expect
true
to ever be called nearly often enough to matter.– John Dvorak
13 hours ago
1
1
If
true
didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.– nigel222
10 hours ago
If
true
didn't exist, the code in the question shows why one might need to invent it! It's a minimal program that can only fail if the system it's on is truly borked. So one can use it to establish if one's access credentials are OK.– nigel222
10 hours ago
|
show 4 more comments
I feel like the accepted answer didn't actually answer your question?
The purpose of doing this is to check that you can actually sudo
.
How this check is performed is via the true
program as explained in the accepted answer.
1
Essentially, this. Alternative could be to check if the user is in sudoers group, but just runningsudo true
is also easy enough of a way, although a bit hacky.
– Sergiy Kolodyazhnyy
yesterday
3
Note that this also requiressudo
to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)
– Mehrdad
yesterday
1
The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.
– mckenzm
23 hours ago
1
And, conversely, you can also be able tosudo
without being in the sudoers group if you (either personally or as a member of some other group) are listed in/etc/sudoers
. But evensudo true
is not infallible, assudo
access can be granted for only specific commands, so you may be able tosudo true
, but not tosudo something_else
, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run withsudo
.
– Dave Sherohman
13 hours ago
2
Also, you can be in thesudoers
group and not be able tosudo
because thesudoers
group is not listed in thesudoers
file. A group with the four letterssudo
in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all usingsudo
.
– jrw32982
8 hours ago
|
show 1 more comment
I feel like the accepted answer didn't actually answer your question?
The purpose of doing this is to check that you can actually sudo
.
How this check is performed is via the true
program as explained in the accepted answer.
1
Essentially, this. Alternative could be to check if the user is in sudoers group, but just runningsudo true
is also easy enough of a way, although a bit hacky.
– Sergiy Kolodyazhnyy
yesterday
3
Note that this also requiressudo
to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)
– Mehrdad
yesterday
1
The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.
– mckenzm
23 hours ago
1
And, conversely, you can also be able tosudo
without being in the sudoers group if you (either personally or as a member of some other group) are listed in/etc/sudoers
. But evensudo true
is not infallible, assudo
access can be granted for only specific commands, so you may be able tosudo true
, but not tosudo something_else
, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run withsudo
.
– Dave Sherohman
13 hours ago
2
Also, you can be in thesudoers
group and not be able tosudo
because thesudoers
group is not listed in thesudoers
file. A group with the four letterssudo
in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all usingsudo
.
– jrw32982
8 hours ago
|
show 1 more comment
I feel like the accepted answer didn't actually answer your question?
The purpose of doing this is to check that you can actually sudo
.
How this check is performed is via the true
program as explained in the accepted answer.
I feel like the accepted answer didn't actually answer your question?
The purpose of doing this is to check that you can actually sudo
.
How this check is performed is via the true
program as explained in the accepted answer.
answered yesterday
MehrdadMehrdad
1,37641534
1,37641534
1
Essentially, this. Alternative could be to check if the user is in sudoers group, but just runningsudo true
is also easy enough of a way, although a bit hacky.
– Sergiy Kolodyazhnyy
yesterday
3
Note that this also requiressudo
to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)
– Mehrdad
yesterday
1
The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.
– mckenzm
23 hours ago
1
And, conversely, you can also be able tosudo
without being in the sudoers group if you (either personally or as a member of some other group) are listed in/etc/sudoers
. But evensudo true
is not infallible, assudo
access can be granted for only specific commands, so you may be able tosudo true
, but not tosudo something_else
, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run withsudo
.
– Dave Sherohman
13 hours ago
2
Also, you can be in thesudoers
group and not be able tosudo
because thesudoers
group is not listed in thesudoers
file. A group with the four letterssudo
in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all usingsudo
.
– jrw32982
8 hours ago
|
show 1 more comment
1
Essentially, this. Alternative could be to check if the user is in sudoers group, but just runningsudo true
is also easy enough of a way, although a bit hacky.
– Sergiy Kolodyazhnyy
yesterday
3
Note that this also requiressudo
to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)
– Mehrdad
yesterday
1
The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.
– mckenzm
23 hours ago
1
And, conversely, you can also be able tosudo
without being in the sudoers group if you (either personally or as a member of some other group) are listed in/etc/sudoers
. But evensudo true
is not infallible, assudo
access can be granted for only specific commands, so you may be able tosudo true
, but not tosudo something_else
, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run withsudo
.
– Dave Sherohman
13 hours ago
2
Also, you can be in thesudoers
group and not be able tosudo
because thesudoers
group is not listed in thesudoers
file. A group with the four letterssudo
in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all usingsudo
.
– jrw32982
8 hours ago
1
1
Essentially, this. Alternative could be to check if the user is in sudoers group, but just running
sudo true
is also easy enough of a way, although a bit hacky.– Sergiy Kolodyazhnyy
yesterday
Essentially, this. Alternative could be to check if the user is in sudoers group, but just running
sudo true
is also easy enough of a way, although a bit hacky.– Sergiy Kolodyazhnyy
yesterday
3
3
Note that this also requires
sudo
to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)– Mehrdad
yesterday
Note that this also requires
sudo
to be installed, so the checks wouldn't be entirely equivalent... you could be in the sudoers group and still not be able to sudo. (This can especially come up if you're e.g. writing a script to setup a new image from a minimal rootfs tarball, which might not have sudo.)– Mehrdad
yesterday
1
1
The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.
– mckenzm
23 hours ago
The OP wants to drop out if you cannot sudo, and get rid of two lines rather than have an else following a noop.
– mckenzm
23 hours ago
1
1
And, conversely, you can also be able to
sudo
without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers
. But even sudo true
is not infallible, as sudo
access can be granted for only specific commands, so you may be able to sudo true
, but not to sudo something_else
, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo
.– Dave Sherohman
13 hours ago
And, conversely, you can also be able to
sudo
without being in the sudoers group if you (either personally or as a member of some other group) are listed in /etc/sudoers
. But even sudo true
is not infallible, as sudo
access can be granted for only specific commands, so you may be able to sudo true
, but not to sudo something_else
, or vice-versa. There's no iron-clad way to test other than by trying to run the command you actually want to run with sudo
.– Dave Sherohman
13 hours ago
2
2
Also, you can be in the
sudoers
group and not be able to sudo
because the sudoers
group is not listed in the sudoers
file. A group with the four letters sudo
in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo
.– jrw32982
8 hours ago
Also, you can be in the
sudoers
group and not be able to sudo
because the sudoers
group is not listed in the sudoers
file. A group with the four letters sudo
in its name is not a valid indication of whether or not a user in that group can do any particular thing or anything at all using sudo
.– jrw32982
8 hours ago
|
show 1 more comment
Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.
Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.
Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.
Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.
Thanks for contributing an answer to Unix & Linux Stack Exchange!
- Please be sure to answer the question. Provide details and share your research!
But avoid …
- Asking for help, clarification, or responding to other answers.
- Making statements based on opinion; back them up with references or personal experience.
To learn more, see our tips on writing great answers.
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');
);
Post as a guest
Required, but never shown
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
2
If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?
– Matt Parkins
yesterday
4
Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?
– Jeff Schaller♦
yesterday
1
see stackoverflow.com/q/10552711/537980
– ctrl-alt-delor
yesterday
1
@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.
– Matt Parkins
yesterday
2
In passing, you probably ought to redirect the error message to the error stream:
echo "Aborting script" >&2
– Toby Speight
yesterday